/*
  Name: cliente.cpp 
  Author: Andr de Castilho
  Date: 03/10/07 23:40
  Description: .CPP que contm as definies dos mtodos da classe Clente
*/

#include <iostream> 
using namespace std;

#include "cliente.h"

Cliente::Cliente()
{
    WSADATA tst;
    // teste para ver se o computador suporta e verso de winsocks utilizada
    // no deve dar problemas, j que todos os windows superiores ao 95 a suportam.
    
    if ( WSAStartup ( MAKEWORD ( 2 , 2 ), &tst ))
    {
        cout << "O computador nao possui a versao 2.0 do Winsocks.";
        cout << "Nao sera possivel criar o servidor." << endl;
        return;
    }
    
    // cria o socket.
    meu_sockt = socket ( AF_INET, SOCK_STREAM, IPPROTO_TCP );
    
    if ( meu_sockt == SOCKET_ERROR )
    {
       cout << "Nao foi possivel criar o socket." << endl;
    }
    
    // define o endereo do cliente.
    // Existem funes que recuperam os ips reais de uma mquina
    // nas respectivas redes das quais participa
    
    meu_end.sin_family           = AF_INET;
    meu_end.sin_port             = htons(50001);
    meu_end.sin_addr.s_addr      = inet_addr("127.0.0.1");
    
}

Cliente::~Cliente()
{
    closesocket ( meu_sockt );
}

void Cliente::conectar(char* ip, unsigned short porta)
{
    char msg[38];
    
    // define o endereo do servidor.
    serv_end.sin_family = AF_INET;
    serv_end.sin_addr.s_addr = inet_addr(ip);
    serv_end.sin_port = htons(porta);
    
    int result = 0;
    result = connect (
                        meu_sockt, 
                        reinterpret_cast < SOCKADDR * > ( &serv_end ), 
                        sizeof ( serv_end )
                      );
    
    if ( result == -1 )
    {
        cout << "Nao foi possivel conectar ao servidor, tente de novo." << endl;
        return;
    }
    cout << "Conexao estabelecida." << endl;
    
    while(1)
    {
        result = recv (
                          meu_sockt, 
                          msg, 
                          38, 
                          0
                       );
                       
        if ( result != -1 )
        {
            cout << msg << endl << endl;
            break;
        }
    }
    
    rotinaPrincipal();
}

void Cliente::conectar( )
{
    char msg[38];
    char ip[16];
    cout << "Digite o ip do servidor ao qual quer se conectar." << endl;
    cout << "\t obs: 127.0.0.1 para o local host\n";
    fflush(stdin);
    gets(ip);
    
    conectar (ip, 3077);

}

//rotina de envio, que contm o menu e a interface do usuario
void Cliente::rotinaPrincipal()
{
    char opc, nom[100];
    int ra, id;
    float sal, bp;
    cout << endl << endl << "-------------------------------------------------------------------------\n" << endl;

    cout << "Digite sua opcao:" << endl;
    cout << "\t- 1 para enviar uma string;" << endl;
    cout << "\t- 2 para enviar um aluno;" << endl;
    cout << "\t- 3 para enviar um professor;" << endl;
    cout << "\t- x para sair." << endl;;
    cin >> opc;
    
    switch(opc)
    {
        case '1':
             {
                  enviaString();
                  system("cls");
                  rotinaPrincipal();
             }
             break;
             
        case '2':
             {
                  cout << "Digite o nome do aluno que deseja cadastrar." << endl;
                  fflush(stdin);
                  gets(nom);
                  cout << "Digite o RA." << endl;
                  cin >> ra;
                  cout << "Digite a ID." << endl;
                  cin >> id;
                  cadastraAluno(nom, ra, id);
                  system("cls");
                  rotinaPrincipal();
             }
             break;
             
        case '3':
             {
                  cout << "Digite o nome do professor que deseja cadastrar." << endl;
                  fflush(stdin);
                  gets(nom);
                  cout << "Digite o salario." << endl;
                  cin >> sal;
                  cout << "Digite o valor da bolsa projeto." << endl;
                  cin >> bp;
                  cadastraProfessor(nom, sal, bp);
                  system("cls");
                  rotinaPrincipal();
             }
             break;
             
        case 'x':
        case 'X':
             {
                  shutdown ( meu_sockt, 1);
                  closesocket( meu_sockt );
                  system("Pause");
                  exit(EXIT_SUCCESS);
             }
             break;
             
        default:
            {
                  cout << "Opcao invalida." << endl;
                  system("cls");
                  rotinaPrincipal();
            }
            break;
    }
}

void Cliente::enviaString ()
{
    char msg[500];
    cout << "Digite a msg que deseja enviar: " << endl;
    fflush(stdin);
    gets ( msg );
    
    send (
            meu_sockt, 
            msg, 
            strlen(msg)+1, 
            0
          );
          
}

void Cliente::cadastraAluno(char* nome, int RA, int ID)
{
     //  criado o objeto da classe aluno que ser enviado;
    Aluno *aux;
    
    // um buffer que conter os dados do aluno;
    char *buff;
    int tipo;
    
    /**************************************************************************/
    //  Rotina que diz ao servidor qual o tipo de dado que est sendo enviado 
    //  inf recebe 1 para sinalizar que  um aluno, e 2 que  um professor    
    char *inf;                                                       
    inf = new char[2];                                               
    strcpy(inf, "1");                                                
    send( meu_sockt, inf, 2, 0);                                     
    
    while( recv( meu_sockt, inf, 2, 0) == -1 ); // fica em loop at receber resposta do servidor                         
    /**************************************************************************/
    
    tipo = atoi(inf);
    if ( tipo == 1 )
    {
        aux = new Aluno(0, 0, 0, nome, RA, ID);
        
        // o buffer  inicializado com o tamanho (em bytes) da estrutura aluno
        // como 1 char tem 1 byte, todo o vetor "buff" ter o mesmo tamanho em bytes
        // que um objeto aluno;
        buff = new char[sizeof(Aluno)];
        
        // dizemos ao compilador que, em vez dele entender aux como um aluno,
        // ele deve interpret-lo como um vetor de char.
        // Ou seja, estamos interpretando aux no como um objeto aluno, mas como um
        // vetor de bytes.
        buff = reinterpret_cast<char *>(aux);
        
        // agora podemos enviar os bytes, que, juntos, representam um aluno, para o servidor.
        send ( meu_sockt, buff, sizeof(Aluno), 0 );
        
        system("pause");
    }
    else
    {
        cout << "Nao foi possivel enviar o aluno." << endl;
    }     
}

void Cliente::cadastraProfessor(char *nome, float sal, float bp)
{
     Professor *aux;
     char *buff;
     char *inf;
     int tipo;
     inf = new char[2];
     strcpy(inf, "2");
     send ( meu_sockt, inf, 2, 0 );
     while ( recv ( meu_sockt, inf, 2, 0) == -1 );
     
     tipo = atoi(inf);
     if(tipo == 1)
     { 
         aux = new Professor(0,0,0, nome, sal, bp);
         buff = new char[sizeof(Professor)];
         buff = reinterpret_cast<char *>(aux);
         send ( meu_sockt, buff, sizeof(Professor), 0 );
         delete aux;
     }
     else
     {
         cout << "Nao foi possivel enviar o professor." << endl;
     }
}

/*
void Cliente::ligaSockt ()
{ 
    int result = 0;
    // funo que conecta o socket  porta que queremos, atribuindo-lhe o endereo devido.
    
    result = bind ( 
                          meu_sockt, 
                          reinterpret_cast < SOCKADDR* > ( &meu_end ),
                          sizeof ( meu_end ) 
                   );
                   
    if( result == -1 )
    {
        cout << "Bind nao pode ser efetuado." << endl;
    }
}
*/
