/*
  Name: servidor.cpp
  Author: Andr de Castilho
  Date: 03/10/07 23:36
  Description: .CPP que contm as definies dos mtodos da classe Servidor
*/

#include "servidor.h"

Servidor::Servidor( char *ip, unsigned short porta, int max ):
cont_msg(0)
{
    WSADATA tst;
    // teste para ver se o computador suporta e verso de winsocks utilizada
    if(WSAStartup(MAKEWORD(2,2), &tst))
    {
        cout << "O computador nao possui a versao 2.0 do Winsocks.";
        cout << "Nao sera possivel criar o servidor." << endl;
    }
    else
    {
        max_conexao = max;
        // Atribui os valores passados pelo construtor ao ip e ao endereo de porta
        // AdressFamily-Internet ser usado como padro nesse programa
        meu_end.sin_family       =     AF_INET;
        meu_end.sin_addr.s_addr  =     inet_addr ( ip );
        meu_end.sin_port         =     htons ( porta );
        
        // cria o socket;
        meu_Sockt = socket( AF_INET, SOCK_STREAM, IPPROTO_TCP);
        
        if( meu_Sockt == SOCKET_ERROR )
        {
            cout << "Erro na criacao do socket." << endl;
            tem_Sockt = false;
        }
        else
        {
            tem_Sockt = true;
        }
    }
}

Servidor::~Servidor()
{
    closesocket ( meu_Sockt );
}

void Servidor::conectaSockt ()
{
    int result = -1;
    result = bind ( 
                            meu_Sockt, 
                            reinterpret_cast <SOCKADDR*> ( &meu_end ), 
                            sizeof ( meu_end )
                   );
    
    if ( result == -1 )
    {
        cout << "Bind nao pode ser efetuado." << endl;
        tem_Canal = false;
    }
    else
    {
        tem_Canal = true;
    }
}

void Servidor::aceitaSockt()
{
    SOCKET outroSockt;
    // listen define o estado da porta aberta pelo servidor.
    // a porta fica esperando ("escutando") pedidos de conexes
    if ( listen ( meu_Sockt , max_conexao ) == -1 )
    {
        cout << "Erro ao entrar em modo de espera de conexoes" << endl;
        tem_Conexao = false;
        return;
    }
    
    cout << "Aguardando conexoes..." << endl;
    
    // loop infinito... 
    do
    {
        // funo que aceita um pedido de conexo feito com "connect()" pelo cliente
        outroSockt = accept( meu_Sockt, NULL, NULL );
    }while ( outroSockt == SOCKET_ERROR );
    
    meu_Sockt = outroSockt;
    
    cout << "Alguem conectou!" << endl;
    // envia uma mensagem confirmando a conexo para o cliente
    send ( meu_Sockt, "Ola. Voce esta conectado ao servidor.", 38, 0);
}

//funo que define o loop que ficar esperando por mensagens do cliente
void Servidor::lacoDeConexao()
{
    while(1)
    {
        bytes_recebidos = recv ( meu_Sockt, buffer, 500, 0);
        
        switch ( bytes_recebidos )
        {
            case -1: continue;
                 
            case 2: {  recebeClasse();
                       cout << "--------------------------------------------------------------------" << endl;
                    }  break;
                 
            case 0: {  cout << "Mensagem num. " << ++cont_msg << endl;
                       cout << "\t Conexo fechada pelo cliente." << endl;
                       shutdown ( meu_Sockt, 1 );
                       closesocket( meu_Sockt );
                       system("pause");
                       WSACleanup();
                       exit(EXIT_SUCCESS);                                                                                        
                    }
                 
            default:{  cout << "Mensagem num. " << ++cont_msg << endl;
                       cout << "\t String de texto recebida.";
                       cout << "\tA mensagem foi: \"";
                       cout << buffer << "\"" << endl;         
                    }
        }
        strcpy(buffer, "");          
    }
}



void Servidor::recebeClasse()
{
    char *resp;
    resp = new char[2];
    strcpy ( resp, "1" );   
    send ( meu_Sockt, resp, 2, 0 );
    
    int tipo = atoi ( buffer );
    
    do
    {
         bytes_recebidos = recv ( meu_Sockt, buffer, 500, 0);
    }
    while ( bytes_recebidos == -1 );
    
    switch ( tipo )
    {
        case 1:  { cadastraAluno();         } break;
        case 2:  { cadastraProfessor();     } break;
        default: { cout << "Houve uma falha durante o recebimento, os dados podem estar corrompidos." << endl; } break;
    }
    lacoDeConexao();
}

void Servidor::cadastraAluno()
{
     Aluno *pAux;
     pAux = reinterpret_cast<Aluno *>(buffer);
     lAlunos.setInfo ( pAux, pAux->getNome() );
     cout << "Msg num." << ++cont_msg << endl;
     cout << "\tAluno recebido e listado!" << endl;
     cout << "\tO nome do aluno eh " << pAux->getNome() << endl;
}

void Servidor::cadastraProfessor()
{
     Professor *pAux;
     pAux = reinterpret_cast<Professor *>(buffer);
     lProfessor.setInfo(pAux, pAux->getNome());
     cout << "Msg num." << ++cont_msg << endl;
     cout << "\tProfessor recebido e listado!" << endl;
     cout << "\tO nome do professor eh " << pAux->getNome() << endl;
}

