#ifndef _LISTA_H_
#define _LISTA_H_

#include <iostream>
#include "Elemento.h"

using namespace std;

template<class TIPO>
class Lista
{
private:
    Elemento<TIPO>*  primeiro;
    Elemento<TIPO>*  atual;

	char nome [150];

public:

    Lista ( );
    ~Lista ( );

    void inicializa ( );
    bool setElemento ( Elemento<TIPO>* elemento );
    bool setInfo ( TIPO* info, char* nome = "" );
    void listeInfos ( );

	TIPO* localizar(char* n);

	void setNome(char* n);
	char* getNome();

	Elemento<TIPO>* getPrimeiro()	{ return primeiro;	}
	Elemento<TIPO>* getAtual()		{ return atual;		}
};

template<class TIPO>
Lista<TIPO>::Lista ( )
{
    inicializa ( );
}

template<class TIPO>
Lista<TIPO>::~Lista ( )
{
}

template<class TIPO>
void Lista<TIPO>::inicializa ( )
{
     primeiro = NULL;
     atual      = NULL;
}

template<class TIPO>
bool Lista<TIPO>::setElemento ( Elemento<TIPO>* elemento )
{
    if (NULL != elemento)
    {

       if (NULL == primeiro)
       {
          primeiro = elemento;
          primeiro->setAnterior ( NULL );
          primeiro->setProximo ( NULL );
          atual = primeiro;
      }
      else
      {
          elemento->setAnterior ( atual );
          elemento->setProximo ( NULL );
          atual->setProximo ( elemento );
          atual = atual->getProximo ( ); 
      }
      return true;
    }
    else
    {
        cout << "Erro, elemento nulo na lista." << endl;
        return false;
    }
}

template<class TIPO>
bool Lista<TIPO>::setInfo ( TIPO *info, char* nome )
{
     if (NULL != info)
     {
          Elemento<TIPO>* elemento;
          elemento = new Elemento<TIPO>();
          elemento->setNome (nome);
          elemento->setInfo (info);
          setElemento (elemento);
          return true;
     }
     else
     {
          printf ( "Erro, elemento (informao) nulo(a) na lista. \n" );
          return false;
     }
}

template<class TIPO>
void Lista<TIPO>::listeInfos()
{
    int cont = 0;
    Elemento<TIPO>* aux;
    aux = primeiro;

    if (NULL != primeiro)
    {
         while (NULL != aux)
         {
              printf ( "%d - %s \n", ++cont, aux->getNome() );
              aux = aux->getProximo();
         }
    }
    else
    {
        cout << "Lista vazia!" << endl;
    }
}


template<class TIPO>
TIPO* Lista<TIPO>::localizar(char* n)
{
	Elemento<TIPO>* aux;
    aux = primeiro;
    while (aux != NULL)
    {
		if (0 == strcmp(n, aux->getNome()))
		{
			return aux->getInfo();
		}
        aux = aux->getProximo();
    }
	return NULL;
}

template<class TIPO>
void Lista<TIPO>::setNome(char* n)
{
	strcpy(nome, n);
}

template<class TIPO>
char* Lista<TIPO>::getNome()
{
	return nome;
}

#endif
